AnnotationIntrospector (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map

## Class AnnotationIntrospector

- java.lang.Object
- - org.codehaus.jackson.map.AnnotationIntrospector

- Direct Known Subclasses:
    AnnotationIntrospector.Pair, JacksonAnnotationIntrospector, JaxbAnnotationIntrospector, NopAnnotationIntrospector

      public abstract class AnnotationIntrospector
      extends Object

  Abstract class that defines API used for introspecting annotation-based configuration for serialization and deserialization. Separated so that different sets of annotations can be supported, and support plugged-in dynamically.

  NOTE: due to rapid addition of new methods (and changes to existing methods), it is strongly recommended that custom implementations should not directly extend this class, but rather extend `NopAnnotationIntrospector`. This way added methods will not break backwards compatibility of custom annotation introspectors.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AnnotationIntrospector.Pair` Helper class that allows using 2 introspectors such that one introspector acts as the primary one to use; and second one as a fallback used if the primary does not provide conclusive or useful result for a method.
    `static class` | `AnnotationIntrospector.ReferenceProperty` Value type used with managed and back references; contains type and logic name, used to link related references

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AnnotationIntrospector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Collection<AnnotationIntrospector>` | `allIntrospectors()` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
    `Collection<AnnotationIntrospector>` | `allIntrospectors(Collection<AnnotationIntrospector> result)` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
    `VisibilityChecker<?>` | `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
    `Boolean` | `findCachability(AnnotatedClass ac)` Method that checks whether specified class has annotations that indicate that it is (or is not) cachable.
    `abstract Class<? extends JsonDeserializer<?>>` | `findContentDeserializer(Annotated am)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `Class<? extends JsonSerializer<?>>` | `findContentSerializer(Annotated am)` Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `abstract String` | `findDeserializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property.
    `abstract Class<?>` | `findDeserializationContentType(Annotated am, JavaType baseContentType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements.
    `abstract Class<?>` | `findDeserializationKeyType(Annotated am, JavaType baseKeyType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use.
    `abstract Class<?>` | `findDeserializationType(Annotated am, JavaType baseType, String propName)` Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type.
    `abstract Object` | `findDeserializer(Annotated am)` Method for getting a deserializer definition on specified method or field.
    `String` | `findEnumValue(Enum<?> value)` Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).
    `Object` | `findFilterId(AnnotatedClass ac)` Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
    `abstract String` | `findGettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter".
    `abstract Boolean` | `findIgnoreUnknownProperties(AnnotatedClass ac)` Method for checking whether an annotation indicates that all unknown properties
    `Object` | `findInjectableValueId(AnnotatedMember m)` Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection.
    `abstract Class<? extends KeyDeserializer>` | `findKeyDeserializer(Annotated am)` Method for getting a deserializer definition for keys of associated `Map` property.
    `Class<? extends JsonSerializer<?>>` | `findKeySerializer(Annotated am)` Method for getting a serializer definition for keys of associated `Map` property.
    `abstract String[]` | `findPropertiesToIgnore(AnnotatedClass ac)` Method for finding list of properties to ignore for given class (null is returned if not specified).
    `TypeResolverBuilder<?>` | `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)` Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values.
    `abstract String` | `findPropertyNameForParam(AnnotatedParameter param)` Method for checking whether given set of annotations indicates property name for associated parameter.
    `TypeResolverBuilder<?>` | `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances.
    `AnnotationIntrospector.ReferenceProperty` | `findReferenceType(AnnotatedMember member)` Note: defined as non-abstract to reduce fragility between versions.
    `abstract String` | `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
    `abstract String` | `findSerializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property.
    `Class<?>` | `findSerializationContentType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
    `JsonSerialize.Inclusion` | `findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)` Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization.
    `Class<?>` | `findSerializationKeyType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
    `abstract String[]` | `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
    `abstract Boolean` | `findSerializationSortAlphabetically(AnnotatedClass ac)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
    `abstract Class<?>` | `findSerializationType(Annotated a)` Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type.
    `abstract JsonSerialize.Typing` | `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
    `abstract Class<?>[]` | `findSerializationViews(Annotated a)` Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in.
    `abstract Object` | `findSerializer(Annotated am)` Method for getting a serializer definition on specified method or field.
    `abstract String` | `findSettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter".
    `List<NamedType>` | `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
    `String` | `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
    `TypeResolverBuilder<?>` | `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
    `Object` | `findValueInstantiator(AnnotatedClass ac)` Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
    `boolean` | `hasAnyGetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
    `boolean` | `hasAnySetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
    `abstract boolean` | `hasAsValueAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
    `boolean` | `hasCreatorAnnotation(Annotated a)` Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
    `boolean` | `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.
    `abstract boolean` | `isHandled(Annotation ann)` Method called by framework to determine whether given annotation is handled by this introspector.
    `abstract boolean` | `isIgnorableConstructor(AnnotatedConstructor c)`
    `abstract boolean` | `isIgnorableField(AnnotatedField f)` Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
    `abstract boolean` | `isIgnorableMethod(AnnotatedMethod m)` Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).
    `Boolean` | `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
    `static AnnotationIntrospector` | `nopInstance()` Factory method for accessing "no operation" implementation of introspector: instance that will never find any annotation-based configuration.
    `static AnnotationIntrospector` | `pair(AnnotationIntrospector a1, AnnotationIntrospector a2)`
    `Boolean` | `shouldUnwrapProperty(AnnotatedMember member)` Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AnnotationIntrospector

          public AnnotationIntrospector()

  - ### Method Detail

    - #### nopInstance

          public static AnnotationIntrospector nopInstance()

      Factory method for accessing "no operation" implementation of introspector: instance that will never find any annotation-based configuration.
      Since:
        1.3

    - #### pair

          public static AnnotationIntrospector pair(AnnotationIntrospector a1,
                                    AnnotationIntrospector a2)

    - #### allIntrospectors

          public Collection<AnnotationIntrospector> allIntrospectors()

      Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

      Default implementation returns a Singleton list with this introspector as contents. This usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

    - #### allIntrospectors

          public Collection<AnnotationIntrospector> allIntrospectors(Collection<AnnotationIntrospector> result)

      Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

      Default implementation adds this introspector in result; this usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

    - #### isHandled

          public abstract boolean isHandled(Annotation ann)

      Method called by framework to determine whether given annotation is handled by this introspector.

    - #### findCachability

          public Boolean findCachability(AnnotatedClass ac)

      Method that checks whether specified class has annotations that indicate that it is (or is not) cachable. Exact semantics depend on type of class annotated and using class (factory or provider).

      Currently only used with deserializers, to determine whether provider should cache instances, and if no annotations are found, assumes non-cachable instances.

      Returns:
        True, if class is considered cachable within context, False if not, and null if introspector does not care either way.

    - #### findRootName

          public abstract String findRootName(AnnotatedClass ac)

      Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.
      Since:
        1.3

    - #### findPropertiesToIgnore

          public abstract String[] findPropertiesToIgnore(AnnotatedClass ac)

      Method for finding list of properties to ignore for given class (null is returned if not specified). List of property names is applied after other detection mechanisms, to filter out these specific properties from being serialized and deserialized.
      Since:
        1.4

    - #### findIgnoreUnknownProperties

          public abstract Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

      Method for checking whether an annotation indicates that all unknown properties
      Since:
        1.4

    - #### isIgnorableType

          public Boolean isIgnorableType(AnnotatedClass ac)

      Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
      Parameters:
        `ac` - Type to check
      Returns:
        Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')
      Since:
        1.7

    - #### findFilterId

          public Object findFilterId(AnnotatedClass ac)

      Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
      Returns:
        Id of the filter to use for filtering properties of annotated class, if any; or null if none found.

    - #### findAutoDetectVisibility

          public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                      VisibilityChecker<?> checker)

      Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).
      Since:
        1.5

    - #### findTypeResolver

          public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                                AnnotatedClass ac,
                                                JavaType baseType)

      Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `ac` - Annotated class to check for annotations
        `baseType` - Base java type of value for which resolver is to be found
      Returns:
        Type resolver builder for given type, if one found; null if none
      Since:
        1.5 -- although changed in 1.8 to pass configuration object

    - #### findPropertyTypeResolver

          public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                        AnnotatedMember am,
                                                        JavaType baseType)

      Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `baseType` - Base java type of property for which resolver is to be found
      Returns:
        Type resolver builder for properties of given entity, if one found; null if none
      Since:
        1.5 -- although changed in 1.8 to pass configuration object

    - #### findPropertyContentTypeResolver

          public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                               AnnotatedMember am,
                                                               JavaType containerType)

      Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `containerType` - Type of property for which resolver is to be found (must be a container type)
      Returns:
        Type resolver builder for values contained in properties of given entity, if one found; null if none
      Since:
        1.5 -- although changed in 1.8 to pass configuration object

    - #### findSubtypes

          public List<NamedType> findSubtypes(Annotated a)

      Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)
      Parameters:
        `a` - Annotated entity (class, field/method) to check for annotations
      Since:
        1.5

    - #### findTypeName

          public String findTypeName(AnnotatedClass ac)

      Method for checking if specified type has explicit name.
      Parameters:
        `ac` - Class to check for type name annotations
      Since:
        1.5

    - #### findReferenceType

          public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)

      Note: defined as non-abstract to reduce fragility between versions.
      Since:
        1.6

    - #### shouldUnwrapProperty

          public Boolean shouldUnwrapProperty(AnnotatedMember member)

      Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e. expect unwrapped representation during deserialization)
      Since:
        1.9

    - #### hasIgnoreMarker

          public boolean hasIgnoreMarker(AnnotatedMember m)

      Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.

      Default implementation calls existing 'isIgnored' methods such as `isIgnorableField(AnnotatedField)` and `isIgnorableMethod(AnnotatedMethod)`.

      Since:
        1.9

    - #### findInjectableValueId

          public Object findInjectableValueId(AnnotatedMember m)

      Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection. Type if identifier needs to be compatible with provider of values (of type `InjectableValues`); often a simple String id is used.
      Parameters:
        `m` - Member to check
      Returns:
        Identifier of value to inject, if any; null if no injection indicator is found

    - #### isIgnorableMethod

          public abstract boolean isIgnorableMethod(AnnotatedMethod m)

      Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).

      Note that this method should ONLY return true for such explicit ignoral cases; and not if method just happens not to be visible for annotation processor.

      Returns:
        True, if an annotation is found to indicate that the method should be ignored; false if not.

    - #### isIgnorableConstructor

          public abstract boolean isIgnorableConstructor(AnnotatedConstructor c)

      Since:
        1.2

    - #### isIgnorableField

          public abstract boolean isIgnorableField(AnnotatedField f)

      Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
      Returns:
        True, if an annotation is found to indicate that the field should be ignored; false if not.

    - #### findSerializer

          public abstract Object findSerializer(Annotated am)

      Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; should not be

    - #### findKeySerializer

          public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated am)

      Method for getting a serializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Since:
        1.8

    - #### findContentSerializer

          public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated am)

      Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Since:
        1.8

    - #### findSerializationInclusion

          public JsonSerialize.Inclusion findSerializationInclusion(Annotated a,
                                                           JsonSerialize.Inclusion defValue)

      Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization. If no annotation is found, method should return given second argument; otherwise value indicated by the annotation
      Returns:
        Enumerated value indicating which properties to include in serialization

    - #### findSerializationType

          public abstract Class<?> findSerializationType(Annotated a)

      Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type. Type returned (if any) needs to be widening conversion (super-type). Declared return type of the method is also considered acceptable.
      Returns:
        Class to use instead of runtime type

    - #### findSerializationKeyType

          public Class<?> findSerializationKeyType(Annotated am,
                                          JavaType baseType)

      Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only be used with `Map` types.
      Returns:
        Class specifying more general type to use instead of declared type, if annotation found; null if not

    - #### findSerializationContentType

          public Class<?> findSerializationContentType(Annotated am,
                                              JavaType baseType)

      Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only used with structured types (arrays, collections, maps).
      Returns:
        Class specifying more general type to use instead of declared type, if annotation found; null if not

    - #### findSerializationTyping

          public abstract JsonSerialize.Typing findSerializationTyping(Annotated a)

      Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.
      Returns:
        Typing mode to use, if annotation is found; null otherwise
      Since:
        1.2

    - #### findSerializationViews

          public abstract Class<?>[] findSerializationViews(Annotated a)

      Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included; otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)
      Parameters:
        `a` - Annotated serializable property (field or getter method)
      Returns:
        Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

    - #### findSerializationPropertyOrder

          public abstract String[] findSerializationPropertyOrder(AnnotatedClass ac)

      Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.
      Since:
        1.4

    - #### findSerializationSortAlphabetically

          public abstract Boolean findSerializationSortAlphabetically(AnnotatedClass ac)

      Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
      Since:
        1.4

    - #### findGettablePropertyName

          public abstract String findGettablePropertyName(AnnotatedMethod am)

      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".

    - #### hasAsValueAnnotation

          public abstract boolean hasAsValueAnnotation(AnnotatedMethod am)

      Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
      Returns:
        True if such annotation is found (and is not disabled); false if no enabled annotation is found

    - #### findEnumValue

          public String findEnumValue(Enum<?> value)

      Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).

      NOTE: implemented since 1.9.11, to make things work even when annotation introspection is disabled.

      Returns:
        Serialized enum value.

    - #### findSerializablePropertyName

          public abstract String findSerializablePropertyName(AnnotatedField af)

      Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a serializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".

    - #### findDeserializer

          public abstract Object findDeserializer(Annotated am)

      Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; but it turns out we really should not try to push BeanProperty through at this point

    - #### findKeyDeserializer

          public abstract Class<? extends KeyDeserializer> findKeyDeserializer(Annotated am)

      Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Since:
        1.3

    - #### findContentDeserializer

          public abstract Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated am)

      Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Since:
        1.3

    - #### findDeserializationType

          public abstract Class<?> findDeserializationType(Annotated am,
                                         JavaType baseType,
                                         String propName)

      Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type. Type must be a narrowing conversion (i.e.subtype of declared type). Declared return type of the method is also considered acceptable.
      Parameters:
        `baseType` - Assumed type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class to use for deserialization instead of declared type

    - #### findDeserializationKeyType

          public abstract Class<?> findDeserializationKeyType(Annotated am,
                                            JavaType baseKeyType,
                                            String propName)

      Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.
      Parameters:
        `baseKeyType` - Assumed key type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findDeserializationContentType

          public abstract Class<?> findDeserializationContentType(Annotated am,
                                                JavaType baseContentType,
                                                String propName)

      Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.
      Parameters:
        `baseContentType` - Assumed content (value) type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findValueInstantiator

          public Object findValueInstantiator(AnnotatedClass ac)

      Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
      Since:
        1.9

    - #### findSettablePropertyName

          public abstract String findSettablePropertyName(AnnotatedMethod am)

      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".

    - #### hasAnySetterAnnotation

          public boolean hasAnySetterAnnotation(AnnotatedMethod am)

      Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### hasAnyGetterAnnotation

          public boolean hasAnyGetterAnnotation(AnnotatedMethod am)

      Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
      Returns:
        True if such annotation is found (and is not disabled), false otherwise
      Since:
        1.6

    - #### hasCreatorAnnotation

          public boolean hasCreatorAnnotation(Annotated a)

      Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### findDeserializablePropertyName

          public abstract String findDeserializablePropertyName(AnnotatedField af)

      Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a deserializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".

    - #### findPropertyNameForParam

          public abstract String findPropertyNameForParam(AnnotatedParameter param)

      Method for checking whether given set of annotations indicates property name for associated parameter. No actual parameter object can be passed since JDK offers no representation; just annotations.